%COMPLETE WITH H-V CALCULATIONS
clc; clear all; load input.mat;
%H-V curve calculations

Tnet=zeros(1,dspeed+1); b=zeros(1,dspeed+1); c=[]; Kp=6.5;
psi=atand(tand(phi)/sind(alpha));
for Hm=[0.1,0.3,0.5,0.8,1.2]
    for v=(0:1:dspeed);          
        if B>10 && Hm>0.4
           Hf=0.26+(B*Hm)^0.5;
           Rch=0.5.*0.8.*150.*9.81.*Hf.^(2).*Kp.*(0.5+(Hm./(2.*Hf))).^(2).*(B+(2.*Hf).*...
           (cosd(22.6)-(1./tand(psi)))).*(uh.*cosd(phi)+sind(psi).*sind(alpha))...
           +0.8.*150.*9.81.*K0.*uh.*Lpar.*Hf.^(2)+150.*9.81.*((L.*T./B.^2)).^3.*Hm.*Awf.*(v./sqrt(9.81.*L)).^2;
        else
           Hf=Hm+(B./2).*tand(2)+(tand(2)+tand(22.6)).*sqrt((B.*(Hm+(B./4).*tand(2))./(tand(2)+tand(22.6))));
           Rch=0.5.*0.8.*150.*9.81.*Hf^(2).*Kp.*(0.5+(Hm./(2.*Hf)))^(2)*(B+(2.*Hf).*...
           (cosd(22.6)-(1./tand(psi)))).*(uh.*cosd(phi)+sind(psi).*sind(alpha))...
           +0.8.*150.*9.81.*K0.*uh.*Lpar.*Hf.^(2)+150.*9.81*((L.*T/B.^2)).^3.*Hm.*Awf.*(v./sqrt(9.81.*L)).^2;
        end
         b(v+1)=Rch/1000;
    end
  c=[c;b];
end

Pd=ppower*0.8*(1-Ploss); %Delivered power 80 % MCR

for v=(1:dspeed-1);
    Tnet(v)=K*((Pd*Dp)^(2/3))*(1-((1/3)*(v/dspeed))-((2/3)*(v/dspeed)^(2))); 
end

figure(1); r=0:1:dspeed; plot(r,c,'--k'); hold on; plot(r,Tnet,'k');
grid on; xlabel('speed (kn)'); ylabel('Resistance in brash ice (kN)')
title('Resistance and Tnet'); hold off; 

c1=c(1,:); c2=c(2,:); c3=c(3,:); c4=c(4,:); c5=c(5,:);  
t=polyfit(r,Tnet,2); t1=t(1); t2=t(2); t3=t(3);

d=polyfit(r,c1,2); d1=d(1); d2=d(2); d3=d(3); syms x;
dx=solve('d1*x^2 + d2*x + d3 = t1*x^2 + t2*x + t3'); cd1=subs(dx);
e=polyfit(r,c2,2); e1=e(1); e2=e(2); e3=e(3);
ex=solve('e1*x^2 + e2*x + e3 = t1*x^2 + t2*x + t3'); ce1=subs(ex);
f=polyfit(r,c3,2); f1=f(1); f2=f(2); f3=f(3);
fx=solve('f1*x^2 + f2*x + f3 = t1*x^2 + t2*x + t3'); cf1=subs(fx);
g=polyfit(r,c4,2); g1=g(1); g2=g(2); g3=g(3);
gx=solve('g1*x^2 + g2*x + g3 = t1*x^2 + t2*x + t3'); cg1=subs(gx);
h=polyfit(r,c5,2); h1=h(1); h2=h(2); h3=h(3);
hx=solve('h1*x^2 + h2*x + h3 = t1*x^2 + t2*x + t3'); ch1=subs(hx);

hh=[0.1,0.3,0.5,0.8,1.2]; vhice=[cd1(1),ce1(1),cf1(1),cg1(1),ch1(1)]; figure(2)
hh2=0.1:.1:1.2; vh=spline(hh,vhice,hh2);
hvi=polyfit(hh2,vh,2); vice=hvi(1).*hh2.^2+hvi(2).*hh2+hvi(3);
plot(vice,hh2,'k'); hold on; grid on; title('h-v curve');
xlabel('speed (kn)'); ylabel('ice thickness (m)');

if dice>0;
    vi= hvi(1)*hm^2 + hvi(2)*hm + hvi(3); 
else
    vi=0;
end

%Service schedule calculations
if tice>0;
    dowice=dtotice-dice;
else 
    dowice=0;
end
timesea=Triptime-(timeport/24);
toperating=Triptime*Annualtrips;
vow=donlyow./(timesea.*24); %speed in open water (not slowsteaming)
Ttot=Annualtrips.*timesea; % Available time (days)
tripsiceroute=tice./(timesea); %days/days
tripsnoiceroute=(Ttot-tice)./timesea; %days/days
if dice>0 && tice>0
    ticewater=dice./vi; %Time in ice for each trip(hours)
else
    ticewater=0;
end

if tice>0;
    vowi=dowice./(timesea.*24-ticewater); %Speed slowsteaming NSR
else
    vowi=0;
end

if tice>0;
    towice=dowice./vowi; %time slowsteaming (hours)
else
    towice=0;
end

ttoticeroute=tice; % total time for ice route (days)
ttotnoiceroute=(Ttot-tice); % total time for route with no ice (days)
totalannualtrips=tripsiceroute+tripsnoiceroute;
annualdisticeroute=tripsiceroute*(dice+dowice);
annualdistancenoiceroute=tripsnoiceroute.*donlyow;
dtotalannual=annualdisticeroute+annualdistancenoiceroute;
cargoonboard=(caputilization./100).*payload;
annualcargocarried=cargoonboard.*totalannualtrips;
distanceice=dice.*tripsiceroute;
distanceslow=donlyow.*tripsiceroute;
distanceow=dowice.*tripsiceroute+donlyow.*tripsnoiceroute;

%Propulsion power for open water
if payload>=1500&&payload<3500 %payload refers to number of TEU 
    averageservicepower=1164.3*(exp(1)).^(0.1296.*vow); %averageservice power is in kW 3000
elseif payload>3500&&payload<4500
    averageservicepower=1197.5*(exp(1)).^(0.1315.*vow); %4000
elseif payload>4500&&payload<5500
    averageservicepower=1227.9*(exp(1)).^(0.1333.*vow); %5000
elseif payload>5500&&payload<6250
    averageservicepower=1309.1*(exp(1)).^(0.1353.*vow); %5750
elseif payload>6250&&payload<6750
    averageservicepower=1392*(exp(1)).^(0.1368*vow); %6500
elseif payload>6750&&payload<7750
    averageservicepower=1476.2*(exp(1)).^(0.1383.*vow); %7250
elseif payload>5500&&payload<9000
    averageservicepower=1561.4*(exp(1)).^(0.1394.*vow); %8000
elseif payload>9000&&payload<=11000
    averageservicepower=1785.5*(exp(1)).^(0.1378.*vow); %10 000
else
    disp('Does not support payload size, rage must be from 1500 to 11000 TEU'); pause;
end

%Fuel consumption slowsteaming in open water:
if payload>=1500&&payload<3500 %payload refers to number of TEU 
    slowsteamingpower=1164.3*(exp(1)).^(0.1296.*vowi); %(kW) 3000
elseif payload>3500&&payload<4500
    slowsteamingpower=1197.5*(exp(1)).^(0.1315.*vowi); %4000
elseif payload>4500&&payload<5500
    slowsteamingpower=1227.9*(exp(1)).^(0.1333.*vowi); %5000
elseif payload>5500&&payload<6250
    slowsteamingpower=1309.1*(exp(1)).^(0.1353.*vowi); %5750
elseif payload>6250&&payload<6750
    slowsteamingpower=1392*(exp(1)).^(0.1368*vowi); %6500
elseif payload>6750&&payload<7750
    slowsteamingpower=1476.2*(exp(1)).^(0.1383.*vowi); %7250
elseif payload>5500&&payload<9000
    slowsteamingpower=1561.4*(exp(1)).^(0.1394.*vowi); %8000
elseif payload>9000&&payload<=11000
    slowsteamingpower=1785.5*(exp(1)).^(0.1378.*vowi); %10 000
else
    disp('Does not support payload size, rage must be from 1500 to 11000 TEU'); pause;
end

%Brash ice resistance (kN)   
if B>10 && hm>0.4
   Hf=0.26+(B*hm)^0.5;
   Rch=(0.5.*0.8.*150.*9.81.*Hf.^(2).*Kp.*(0.5+(hm./(2.*Hf))).^(2).*(B+(2.*Hf).*...
   (cosd(22.6)-(1./tand(psi)))).*(uh.*cosd(phi)+sind(psi).*sind(alpha))...
   +0.8.*150.*9.81.*K0.*uh.*Lpar.*Hf.^(2)+150.*9.81.*((L.*T./B.^2)).^3.*hm.*Awf.*(vi./sqrt(9.81.*L)).^2)./1000;
else
   Hf=hm+(B./2).*tand(2)+(tand(2)+tand(22.6)).*sqrt((B.*(hm+(B./4).*tand(2))./(tand(2)+tand(22.6))));
   Rch=(0.5.*0.8.*150.*9.81.*Hf^(2).*Kp.*(0.5+(hm./(2.*Hf)))^(2)*(B+(2.*Hf).*...
   (cosd(22.6)-(1./tand(psi)))).*(uh.*cosd(phi)+sind(psi).*sind(alpha))...
   +0.8.*150.*9.81.*K0.*uh.*Lpar.*Hf.^(2)+150.*9.81*((L.*T/B.^2)).^3.*hm.*Awf.*(vi./sqrt(9.81.*L)).^2)./1000;
end

%Bunker comsumption
Rslow=(slowsteamingpower.*(1-Ploss))/(vowi*0.5144);
Row=(averageservicepower.*(1-Ploss))/(vow*0.5144);
%Consumption ice 
if dice>0
    consumptionice=(sfchfo.*ticewater.*ppower*0.8)./(1*10^6); %(ton)
else
    consumptionice=0;
end
%consumption slowsteaming
if tice>0
    consumptionslow=(sfchfo.*towice.*slowsteamingpower)./(1*10^6) ;
else
    consumptionslow=0;
end
%consumption open water route
comsumptionopenwaterroute=(sfchfo.*ttotnoiceroute.*24.*averageservicepower)./(1*10^6);
%Total for both routes:
annualbunkerconsumption=consumptionice.*tripsiceroute...
    +comsumptionopenwaterroute+consumptionslow.*tripsiceroute;
annualbunkercost=annualbunkerconsumption.*chfo;
bunkercostprnm=annualbunkercost./dtotalannual;

%Emissions
CO2factor=3.17;
annualco2consumption=CO2factor*annualbunkerconsumption;
transporteffuel=(annualbunkerconsumption*10^6)/(annualcargocarried*dtotalannual*wunit); %g [g fuel/ton*nm]
transporteffc02=transporteffuel*CO2factor; % [g CO2/ton*nm]

%costs
cargohandlingcost=chandling.*annualcargocarried;
portcost=cportcall.*totalannualtrips*gtonnage;
crewwages=cpayroll.*ncrew*npersposition;
shorepersonellcost=npersonell.*cpayroll.*(coverhead/100);
costsales=csale.*annualcargocarried;
cexpensesow=cinsurance*tripsnoiceroute+((cmaintenance*distanceow)/dtotalannual);

if tice>0
    cexpensesice=cinsuranceice*tripsiceroute+((cmaintenance.*2.*distanceice)./dtotalannual); 
else 
    cexpensesice=0;
end

tot_net_tonnage=payload*wunit;
cfee=(5000*7.21+5000*6.13+10000*3.37+20000*2.42+((tot_net_tonnage-40000)*2.42))...
    *tripsnoiceroute;
cicefee=icefee.*tripsiceroute;
  
%Capital costs for first year
annualshipdepcost=80./shiplifetime;
annualrepayments=(equity./100).*cship*(interest./100)*((1+(interest./100))...
    .^loantime)/((1+(interest./100)).^loantime-1); %includes annual backpayments and interest;; 
capitalcosts=annualrepayments+((annualshipdepcost./100).*cship);
grossrevenue= cargohandlingcost+portcost+crewwages+provisions+shorepersonellcost...
    +costsales+cexpensesow+cexpensesice+capitalcosts+cfee+cicefee;

%RFR
cannualrunning=cargohandlingcost+portcost+crewwages+shorepersonellcost...
    +costsales+cexpensesow+cexpensesice+cfee+cicefee+annualbunkercost+capitalcosts;
LCC=cannualrunning*((1+(interest/100))^shiplifetime-1)/((interest/100)*(1+(interest/100))^shiplifetime);
npvrate=((1+(interest/100))^shiplifetime-1)/((interest/100)*(1+(interest/100))^shiplifetime);
revenue=LCC/npvrate;
RFR=revenue/annualcargocarried;

%SMF
convfactor=8760;
aac=cargohandlingcost+portcost+crewwages+shorepersonellcost+costsales+cexpensesow+...
    cexpensesice+capitalcosts+cfee+cicefee+annualbunkercost;
utilizationfactor=toperating./ttot;

%SMFow
operatingspeedfactor=vow./dspeed;
porttimefactor=ttotnoiceroute./toperating;
k=(convfactor*utilizationfactor.*(caputilization./100)*operatingspeedfactor).*porttimefactor;
smfow=k.*(ppower./aac).*(payload./Row).*peff;

%SMFice
operatingspeedfactorice=((vowi.*dowice+vi.*dice)/(dice+dowice))/dspeed;
porttimefactorice=ttoticeroute./toperating;
kice=(convfactor*utilizationfactor.*(caputilization./100)*operatingspeedfactorice).*porttimefactorice;
Rice=(Rch*dice+dowice*Rslow)./(dice+dowice);
pice=(peffice*dice+dowice.*peff)./(dice+dowice); %Propeller efficiency ice as fucntion of fraction served in ice
if tice>0 
    smfice=kice.*(ppower./aac).*(payload./Rice).*pice;
else 
    smfice=0;
end
%SMFtot
smftot=smfow + smfice;

%PRINT
out=fopen('results','wt');
pservices=[tripsiceroute;tripsnoiceroute;totalannualtrips;dtotalannual;annualcargocarried];
sprintf(' Service Schedule')
sprintf(' Annual trips trough ice route = %23.0f \n Annual trips trough open water route = %20.0f \n Annual trips combined = %29.0f \n Annual distance covered = %27.0f \n Annual cargo carried = %30.0f TEU ', pservices)
fprintf(out,' Annual trips trough ice route = %23.0f \n Annual trips trough open water route = %20.0f \n Annual trips combined = %29.0f \n Annual distance covered = %27.0f \n Annual cargo carried = %30.0f TEU \n\n', pservices);
pbunker=[consumptionice;comsumptionopenwaterroute;annualbunkerconsumption;...
    annualbunkercost;bunkercostprnm;annualco2consumption;transporteffuel;transporteffc02];
sprintf(' Bunker ')
sprintf(' Bunker consumption on ice route = %1.0f ton \n Bunker consumption on open water route = %1.f ton \n Annual total bunker consumption = %1.f ton \n Annual bunker cost = %1.0f USD \n Bunker cost pr nm = %1.0f ton/nm \n Annual CO2 emissions = %1.0f ton \n Transporteff. = %1g [g(fuel)/ton*nm] \n Transporteff. = %1g [g(Co2)/ton*nm] ',pbunker)
fprintf(out,' Annual bunker consumption on ice route = %1.0f ton \n Annual bunker consumption on open water route = %1.f ton \n Annual total bunker consumption = %1.f ton \n Annual bunker cost = %1.0f USD \n Bunker cost pr nm = %1.0f ton/nm \n Annual CO2 emissions = %1.0f ton \n Transporteff. = %1g [g(fuel)/ton*nm] \n Transporteff. = %1g [g(Co2)/ton*nm] \n\n',pbunker);
pcosts=[cargohandlingcost;portcost;crewwages;shorepersonellcost;costsales;cexpensesow;cexpensesice;capitalcosts;LCC];
sprintf(' Annual cargo handling costs = %1.0f USD \n Annual port costs = %1.0f USD \n Annual crew wages = %1.0f USD \n Annual shore crew cost = %1.0f USD \n Annual cost of sales = %1.0f USD \n Annual insurance and maintenance expenses open water route = %1.0f \n Annual insurance and maintenance expenses ice route = %1.0f \n Annual capital costs = %1.0f \n LCC = %1.0f ',pcosts) 
fprintf(out,' Annual cargo handling costs = %1.0f USD \n Annual port costs = %1.0f USD \n Annual crew wages = %1.0f USD \n Annual shore crew cost = %1.0f USD \n Annual cost of sales = %1.0f USD \n Annual insurance and maintenance expenses open water route = %1.0f \n Annual insurance and maintenance expenses ice route = %1.0f \n Annual capital costs = %1.0f \n LCC = %1.0f ',pcosts);
rfr=RFR;
sprintf(' Required freight rate = %1.0f USD/TEU \n ',rfr)
smf=[smfow;smfice;smftot];
sprintf(' Ship merit factor open water = %1g \n Ship merit factor ice = %g \n Total ship merit factor = %1g ', smf)
fprintf(out,' Ship merit factor open water = %g \n Ship merit factor ice = %g \n Total ship merit factor = %g ', smf);
xlswrite('results',[pservices;pbunker;pcosts;rfr;smf]);
fclose('all');
save input.mat
sprintf('done') 